/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the WriteActionAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WriteActionAllOf{}

// WriteActionAllOf struct for WriteActionAllOf
type WriteActionAllOf struct {
	WriteMode         *string       `json:"write_mode,omitempty"`
	Stream            *bool         `json:"stream,omitempty"`
	UniqueColumns     []interface{} `json:"unique_columns,omitempty"`
	SetupInstructions *string       `json:"setup_instructions,omitempty"`
}

// NewWriteActionAllOf instantiates a new WriteActionAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWriteActionAllOf() *WriteActionAllOf {
	this := WriteActionAllOf{}
	return &this
}

// NewWriteActionAllOfWithDefaults instantiates a new WriteActionAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWriteActionAllOfWithDefaults() *WriteActionAllOf {
	this := WriteActionAllOf{}
	return &this
}

// GetWriteMode returns the WriteMode field value if set, zero value otherwise.
func (o *WriteActionAllOf) GetWriteMode() string {
	if o == nil || IsNil(o.WriteMode) {
		var ret string
		return ret
	}
	return *o.WriteMode
}

// GetWriteModeOk returns a tuple with the WriteMode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteActionAllOf) GetWriteModeOk() (*string, bool) {
	if o == nil || IsNil(o.WriteMode) {
		return nil, false
	}
	return o.WriteMode, true
}

// HasWriteMode returns a boolean if a field has been set.
func (o *WriteActionAllOf) HasWriteMode() bool {
	if o != nil && !IsNil(o.WriteMode) {
		return true
	}

	return false
}

// SetWriteMode gets a reference to the given string and assigns it to the WriteMode field.
func (o *WriteActionAllOf) SetWriteMode(v string) {
	o.WriteMode = &v
}

// GetStream returns the Stream field value if set, zero value otherwise.
func (o *WriteActionAllOf) GetStream() bool {
	if o == nil || IsNil(o.Stream) {
		var ret bool
		return ret
	}
	return *o.Stream
}

// GetStreamOk returns a tuple with the Stream field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteActionAllOf) GetStreamOk() (*bool, bool) {
	if o == nil || IsNil(o.Stream) {
		return nil, false
	}
	return o.Stream, true
}

// HasStream returns a boolean if a field has been set.
func (o *WriteActionAllOf) HasStream() bool {
	if o != nil && !IsNil(o.Stream) {
		return true
	}

	return false
}

// SetStream gets a reference to the given bool and assigns it to the Stream field.
func (o *WriteActionAllOf) SetStream(v bool) {
	o.Stream = &v
}

// GetUniqueColumns returns the UniqueColumns field value if set, zero value otherwise.
func (o *WriteActionAllOf) GetUniqueColumns() []interface{} {
	if o == nil || IsNil(o.UniqueColumns) {
		var ret []interface{}
		return ret
	}
	return o.UniqueColumns
}

// GetUniqueColumnsOk returns a tuple with the UniqueColumns field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteActionAllOf) GetUniqueColumnsOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.UniqueColumns) {
		return nil, false
	}
	return o.UniqueColumns, true
}

// HasUniqueColumns returns a boolean if a field has been set.
func (o *WriteActionAllOf) HasUniqueColumns() bool {
	if o != nil && !IsNil(o.UniqueColumns) {
		return true
	}

	return false
}

// SetUniqueColumns gets a reference to the given []interface{} and assigns it to the UniqueColumns field.
func (o *WriteActionAllOf) SetUniqueColumns(v []interface{}) {
	o.UniqueColumns = v
}

// GetSetupInstructions returns the SetupInstructions field value if set, zero value otherwise.
func (o *WriteActionAllOf) GetSetupInstructions() string {
	if o == nil || IsNil(o.SetupInstructions) {
		var ret string
		return ret
	}
	return *o.SetupInstructions
}

// GetSetupInstructionsOk returns a tuple with the SetupInstructions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteActionAllOf) GetSetupInstructionsOk() (*string, bool) {
	if o == nil || IsNil(o.SetupInstructions) {
		return nil, false
	}
	return o.SetupInstructions, true
}

// HasSetupInstructions returns a boolean if a field has been set.
func (o *WriteActionAllOf) HasSetupInstructions() bool {
	if o != nil && !IsNil(o.SetupInstructions) {
		return true
	}

	return false
}

// SetSetupInstructions gets a reference to the given string and assigns it to the SetupInstructions field.
func (o *WriteActionAllOf) SetSetupInstructions(v string) {
	o.SetupInstructions = &v
}

func (o WriteActionAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WriteActionAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.WriteMode) {
		toSerialize["write_mode"] = o.WriteMode
	}
	if !IsNil(o.Stream) {
		toSerialize["stream"] = o.Stream
	}
	if !IsNil(o.UniqueColumns) {
		toSerialize["unique_columns"] = o.UniqueColumns
	}
	if !IsNil(o.SetupInstructions) {
		toSerialize["setup_instructions"] = o.SetupInstructions
	}
	return toSerialize, nil
}

type NullableWriteActionAllOf struct {
	value *WriteActionAllOf
	isSet bool
}

func (v NullableWriteActionAllOf) Get() *WriteActionAllOf {
	return v.value
}

func (v *NullableWriteActionAllOf) Set(val *WriteActionAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableWriteActionAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableWriteActionAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWriteActionAllOf(val *WriteActionAllOf) *NullableWriteActionAllOf {
	return &NullableWriteActionAllOf{value: val, isSet: true}
}

func (v NullableWriteActionAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWriteActionAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
